
"""Read diffkk.inp"""

default = {
    'active': False,
    'iprint': 0,
    'egrid': 1,
    'elow': 200,
    'ehigh': 500,
    'ewidth': -1.0,
    'epad': 5,
    'npad': 20,
    'label': ' e         f1         f2         f1_cl         f2_cl',
    'title': ' '
    }

def str2lg(s):
    logic = {'false': False, 'f': False, 0: False,
         'true': True, 't': True, 1: True}
    s = s.lower()
    return logic.get(s, False)

def dkinp(inpfil = None):
    if inpfil is None:
        inpfil = "TEMP_files/diffkk.inp"
    f = open(inpfil, 'r')
    result = default 
    result['inpfil'] = inpfil
    for line in f:
        line = line.strip()
        if line.startswith("#"): continue
        if line.startswith('end'): break
        line_c = line.split("%") # remove comments
        line_c = line_c[0].split("=")
        if len(line_c) == 2:
            result[line_c[0].strip()] = line_c[1].strip()
        else:
            continue   # don't know what it is
    # update some with different names and use defaults
    result['outfil'] = result.get('out', 'dk.out')
    result['xmufil'] = result.get('xmu', 'xmu.dat')
    result['iatz'] = result.get('iz', -1)
    result['imucol'] = result.get('mucol', 2)
    result['iencol'] = result.get('encol', 1)
    result['isfeff'] = str2lg(result.get('isfeff', 'true'))
    result['f2tof1'] = str2lg(result.get('f2_to_f1', 'true'))
    result['f2tof1'] = not str2lg(result.get('f1_to_f2', 'false'))
    
    return result
