import sys
from PyQt4 import QtGui, QtCore
import dabax

class AtomicPropertiesDialog(QtGui.QDialog):
    def __init__(self, parent = None):
        super(AtomicPropertiesDialog,self).__init__(parent)
        self.setWindowTitle('Atomic Properties')
        self.setWindowIcon(QtGui.QIcon('icons/periodic.png'))
        self.inpGroup = QtGui.QGroupBox()
        self.el_lab = QtGui.QLabel('Element name: ')
        self.el = QtGui.QLineEdit()
        self.prop_lab = QtGui.QLabel('Property: ')
        at_list = ['Z', 'AtomicRadius[A]', 'CovalentRadius[A]', 'AtomicMass', 'BoilingPoint[K]', 'MeltingPoint[K]', 'Density[g/ccm]', 'AtomicVolume', 'CoherentScatteringLength[1E-12cm]', 'IncoherentX-section[barn]', 'Absorption@1.8A[barn]', 'DebyeTemperature[K]', 'ThermalConductivity[W/cmK]']
        self.listBox = QtGui.QComboBox()
        self.listBox.addItems(at_list)
        self.showButton = QtGui.QPushButton('GO')
        self.result = QtGui.QLineEdit()
        self.inpGroupLayout = QtGui.QGridLayout()
        self.inpGroupLayout.addWidget(self.el_lab, 0,0)
        self.inpGroupLayout.addWidget(self.el, 0,1)
        self.inpGroupLayout.addWidget(self.prop_lab, 1,0)
        self.inpGroupLayout.addWidget(self.listBox, 1,1)
        self.inpGroupLayout.addWidget(self.showButton, 2,0)
        self.inpGroupLayout.addWidget(self.result, 2,1)
        self.inpGroup.setLayout(self.inpGroupLayout)
        
        self.buttonGroup = QtGui.QGroupBox()
        self.okButton = QtGui.QPushButton('OK')
        self.buttonGroupLayout = QtGui.QVBoxLayout()
        self.buttonGroupLayout.addWidget(self.okButton)
        self.connect(self.okButton, QtCore.SIGNAL('clicked()'), self, QtCore.SLOT('accept()'))
        self.buttonGroup.setLayout(self.buttonGroupLayout)
        
        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.inpGroup)
        layout.addWidget(self.buttonGroup)
        self.setLayout(layout)
        
        self.connect(self.showButton, QtCore.SIGNAL('clicked()'),self.CalcProperty)
        
    def CalcProperty(self):
        element = str(self.el.text())
        property = str(self.listBox.currentText())
        try:
            res = dabax.AtomicProperties(element,property)
            self.result.setText(str(res))
        except:
            pass
        
        

        
        
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = AtomicPropertiesDialog()
    qb.show()
    sys.exit(app.exec_())
    
    