from xml.dom.minidom import *
from string import *

# inp_file = 'TEST/TiO2.xml'
inp_file = 'TEST/oro_fit.xml'
# inp_file = 'TEST/pippo.xml'

class ReadXml:

    def readInp(self, inFile):
        document = parse(inFile)
        parentNode = document.firstChild
# Search for nodes
        f_node = []
        for nodes in parentNode.childNodes:
            if nodes.nodeName == 'f':
                f_node.append(nodes)
        tf0_node              = parentNode.getElementsByTagName('tf0')
        tf12_node             = parentNode.getElementsByTagName('tf12')
        ift_node              = parentNode.getElementsByTagName('ift')
        bff_node              = parentNode.getElementsByTagName('bff')
        bsum_node             = parentNode.getElementsByTagName('bsum')
        KK_node               = parentNode.getElementsByTagName('KK')
        stack_node            = parentNode.getElementsByTagName('stack')
        dv_node               = parentNode.getElementsByTagName('dv')
        scanlist_node         = parentNode.getElementsByTagName('scanlist')
        KK_write_node         = parentNode.getElementsByTagName('KK_write')
        fit_node              = parentNode.getElementsByTagName('fit')
        comparison_write_node = parentNode.getElementsByTagName('comparison_write')
        Minimise_node         = parentNode.getElementsByTagName('Minimise')
        GeFit_node            = parentNode.getElementsByTagName('MinimiseGeFit')
        inpDic = {'tf0':tf0_node, 'tf12': tf12_node, 'ift':ift_node, 'bff':bff_node, 
            'bsum':bsum_node, 'KK':KK_node, 'stack':stack_node, 'dv':dv_node, 'scanlist':scanlist_node,
            'KK_write':KK_write_node, 'fit':fit_node, 'comparison_write':comparison_write_node,
            'Minimise':Minimise_node, 'GeFit':GeFit_node,'f_nodes':f_node}
        return inpDic


    def manageTF0(self, dic):
        inp = dic['tf0'][0]
        s_node = inp.getElementsByTagName('s')[0]
        out = s_node.childNodes[0]
        return out.data

    def manageTF12(self, dic):
        inp = dic['tf12'][0]
        s_node = inp.getElementsByTagName('s')[0]
        out = s_node.childNodes[0]
        return out.data
    
    def manageGEFIT(self, dic):
        if dic['GeFit'] != []:
            return 1
        else:
            return 0
    

# it doesn't consider ift from the stack. it will be considered in a different function

    def manageIFT(self, dic):
        inp = dic['ift']
        out = []
        for i in range(len(inp)):
            if not inp[i].attributes:
                out.append(inp[i])
        result = []
        for a in range(len(out)):
            name = str(out[a].firstChild.data)
            name = replace(name, '\n', '')
            name = replace(name, ' ', '')
            s_node = out[a].getElementsByTagName('s')
            s_data = str(s_node[0].childNodes[0].data)
            f_node = out[a].getElementsByTagName('f')
            f_data = str(f_node[0].childNodes[0].data)
            temp = [name, s_data, f_data]
            result.append(temp)
        return result
        
    def manageBFF(self, dic):
        inp = dic['bff']
        result = []
        for i in range(len(inp)):
            name = str(inp[i].firstChild.data)
            name = replace(name, '\n', '')
            name = replace(name, ' ', '')
            s_node = inp[i].getElementsByTagName('s')
            s_data = str(s_node[0].childNodes[0].data)
            f_node = inp[i].getElementsByTagName('f')
            temp = [name, s_data]
            for a in range(len(f_node)):
                temp.append(str(f_node[a].childNodes[0].data))
            result.append(temp)
        return result

    def manageBSUM(self,dic):
        inp = dic['bsum']
        result = []
        for i in range(len(inp)):
            name = str(inp[i].firstChild.data)
            name = replace(name, '\n', '')
            name = replace(name, ' ', '')
            f_node = inp[i].getElementsByTagName('f')
            temp = [name]
            for a in range(len(f_node)):
                temp.append(str(f_node[a].childNodes[0].data))
            result.append(temp)
        return result

    def manageKK(self, dic):
        inp = dic['KK']
        result = []
        for i in range(len(inp)):
            name = str(inp[i].firstChild.data)
            name = replace(name, '\n', '')
            name = replace(name, ' ', '')
            jlist = []
            j_nodes = inp[i].getElementsByTagName('bjoin')
            j_node = j_nodes[0].getElementsByTagName('f')
            for k in range(len(j_node)):
                jlist.append(str(j_node[k].childNodes[0].data))
            f_node = inp[i].getElementsByTagName('f')
            temp = [name,jlist]
            for a in range(len(f_node)-4):
                temp.append(str(f_node[a+4].childNodes[0].data))
            result.append(temp)
        return result


    def manageSTACK(self, dic):
        inp = dic['stack']
        inp1 = dic['f_nodes']
        result = []
        for i in range(len(inp)):
            if not inp[i].attributes:
                repetitions = '1'
            else:
                rep = inp[i].attributes["repetitions"]
                repetitions = rep.value
            l_nodes = inp[i].getElementsByTagName('layer')
            
            for k in range(len(l_nodes)):
                llist = []
                t_f = []
                name = str(l_nodes[k].firstChild.data)
                name = replace(name, '\n', '')
                name = replace(name, ' ', '')
                f_node = l_nodes[k].getElementsByTagName('f')
                llist.append(str(f_node[0].childNodes[0].data))
                llist.append(str(f_node[1].childNodes[0].data))
                ift_node = []
                if inp[i].getElementsByTagName('ift'):
                    tp_node = inp[i].getElementsByTagName('ift')
                    for z in range(len(tp_node)):
                        ift_node.append(tp_node[z])
                if inp[i].getElementsByTagName('ifos'):
                    tp_node = inp[i].getElementsByTagName('ifos')
                    for z in range(len(tp_node)):
                        ift_node.append(tp_node[z])
                if inp[i].getElementsByTagName('KK'):
                    tp_node = inp[i].getElementsByTagName('KK')
                    for z in range(len(tp_node)):
                        ift_node.append(tp_node[z])
                slist = ift_node[k].getElementsByTagName('s')
                flist = ift_node[k].getElementsByTagName('f')
                for f in range(len(inp1)):
                    if split(split(inp1[f].childNodes[0].data)[0],'_')[0] == name and split(split(inp1[f].childNodes[0].data)[0],'_')[1] == "density":
                        llist.append(replace(str(inp1[f].childNodes[0].data),str(name)+'_','' ))
                matbox = [name, llist]
                for m in range(len(slist)):
                    dati = []
                    n_elem = replace(str(slist[m].childNodes[0].data), ' ', '')
                    dati.append(n_elem)
                    for j in range(len(inp1)):
                        if split(split(inp1[j].childNodes[0].data)[0],'_')[0] == name and split(split(inp1[j].childNodes[0].data)[0],'_')[1] == n_elem:
                            dati.append(str(split(inp1[j].childNodes[0].data)[1]))
                    matbox.append(dati)
                result.append(matbox)
        return result, repetitions
                
    def manageSCAN(self, dic):
        inp = dic['scanlist']
        scanlist = inp[0].getElementsByTagName('scan')
        result = []
        name_node = scanlist[0].getElementsByTagName('s')
        result.append(str(name_node[0].childNodes[0].data))
        flist = scanlist[0].getElementsByTagName('f')
        dati = []
        for k in range(len(flist)):
            dati.append(str(flist[k].childNodes[0].data))
        result.append(dati)
        return result
        
    def manageCpW(self, dic):
        inp = dic['comparison_write']
        s_node = inp[0].getElementsByTagName('s')
        result = s_node[0].childNodes[0].data
        return result
    
    def manageMIN(self, dic):
        inp = dic['Minimise']
        result = []
        s_node = inp[0].getElementsByTagName('s')
        result.append(str(s_node[0].childNodes[0].data))
        f_nodes = inp[0].getElementsByTagName('f')
        for i in range(len(f_nodes)):
            result.append(str(f_nodes[i].childNodes[0].data))
        return result

                
            


if __name__ == '__main__':
    rd = ReadXml()
    dic = rd.readInp(inp_file)
    tf0 = rd.manageTF0(dic)
    tf12 = rd.manageTF12(dic)
    #ift = rd.manageIFT(dic)
    #bff = rd.manageBFF(dic)
    #bsum = rd.manageBSUM(dic)
    #KK = rd.manageKK(dic)
    stack, rep = rd.manageSTACK(dic)
#     scan = rd.manageSCAN(dic)
    #CpW = rd.manageCpW(dic)
    #minim = rd.manageMIN(dic)
    print stack


