import sys, os
from PyQt4 import QtGui, QtCore
from numpy import *
from string import atof
import dabax

class SimulationDialog(QtGui.QDialog):
    def __init__(self, parent = None):
        super(SimulationDialog,self).__init__(parent)
        self.setWindowTitle('Simulate Reflectivity')
        self.home = os.getenv("HOME")
        self.inpGroup = QtGui.QGroupBox('Simulation')
        self.scanLabel = QtGui.QLabel('Scan')
        self.scanCombo = QtGui.QComboBox()
        self.scanCombo.addItems(['Angle', 'Energy (eV)'])
        self.connect(self.scanCombo,QtCore.SIGNAL("currentIndexChanged(QString)"),self.Change)
        self.fixLabel = QtGui.QLabel('At Fixed:')
        if str(self.scanCombo.currentText()) == 'Angle':
            self.texto = 'Energy (eV)'
        elif str(self.scanCombo.currentText()) == 'Energy (eV)':
            self.texto = 'Angle'
        self.fix = QtGui.QLabel(self.texto)
        self.valore = QtGui.QLineEdit()
        self.fromLabel = QtGui.QLabel('From')
        self.toLabel = QtGui.QLabel('To')
        self.stepLabel = QtGui.QLabel('Points')
        self.fromEdit = QtGui.QLineEdit()
        self.toEdit = QtGui.QLineEdit()
        self.stepEdit = QtGui.QLineEdit()
        self.plotButton = QtGui.QPushButton('PLOT')
        self.saveButton = QtGui.QPushButton('SAVE')
        self.inpGroupLayout = QtGui.QGridLayout()
        self.inpGroupLayout.addWidget(self.scanLabel,0,0)
        self.inpGroupLayout.addWidget(self.scanCombo,0,1)
        self.inpGroupLayout.addWidget(self.fixLabel,0,2)
        self.inpGroupLayout.addWidget(self.fix,0,3)
        self.inpGroupLayout.addWidget(self.valore,0,4)
        self.inpGroupLayout.addWidget(self.fromLabel,1,0)
        self.inpGroupLayout.addWidget(self.toLabel,1,2)
        self.inpGroupLayout.addWidget(self.stepLabel,2,0)
        self.inpGroupLayout.addWidget(self.fromEdit,1,1)
        self.inpGroupLayout.addWidget(self.toEdit,1,3)
        self.inpGroupLayout.addWidget(self.stepEdit,2,1)
        self.inpGroupLayout.addWidget(self.plotButton,2,2)
        self.inpGroupLayout.addWidget(self.saveButton,2,3)
        self.inpGroup.setLayout(self.inpGroupLayout)
        
        self.inp2Group = QtGui.QGroupBox('Atomic Properties')
        self.el_lab = QtGui.QLabel('Element name: ')
        self.el = QtGui.QLineEdit()
        self.prop_lab = QtGui.QLabel('Property: ')
        at_list = ['Z', 'AtomicRadius[A]', 'CovalentRadius[A]', 'AtomicMass', 'BoilingPoint[K]', 'MeltingPoint[K]', 'Density[g/ccm]', 'AtomicVolume', 'CoherentScatteringLength[1E-12cm]', 'IncoherentX-section[barn]', 'Absorption@1.8A[barn]', 'DebyeTemperature[K]', 'ThermalConductivity[W/cmK]']
        self.listBox = QtGui.QComboBox()
        self.listBox.addItems(at_list)
        self.showButton = QtGui.QPushButton('GO')
        self.result = QtGui.QLineEdit()
        self.inp2GroupLayout = QtGui.QGridLayout()
        self.inp2GroupLayout.addWidget(self.el_lab, 0,0)
        self.inp2GroupLayout.addWidget(self.el, 0,1)
        self.inp2GroupLayout.addWidget(self.prop_lab, 0,2)
        self.inp2GroupLayout.addWidget(self.listBox, 0,3)
        self.inp2GroupLayout.addWidget(self.showButton, 2,0)
        self.inp2GroupLayout.addWidget(self.result, 2,1)
        self.inp2Group.setLayout(self.inp2GroupLayout)
        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.inpGroup)
        layout.addWidget(self.inp2Group)
        self.setLayout(layout)
        self.connect(self.showButton, QtCore.SIGNAL('clicked()'),self.CalcProperty)
        
    def Change(self):
        if str(self.scanCombo.currentText()) == 'Angle':
            self.fix.setText('Energy (eV)')
        if str(self.scanCombo.currentText()) == 'Energy (eV)':
            self.fix.setText('Angle')
            
    def CalcProperty(self):
        element = str(self.el.text())
        property = str(self.listBox.currentText())
        try:
            res = dabax.AtomicProperties(element,property)
            self.result.setText(str(res))
        except:
            pass
        
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = SimulationDialog()
    qb.show()
    sys.exit(app.exec_())
        
        
        
                
        
