import sys, os
from PyQt4 import QtCore, QtGui
import string
from string import atoi, atof
from time import strftime
import ppmxml
from numpy import array, savetxt, loadtxt, transpose
import shutil
import Ifeffit
iff = Ifeffit.Ifeffit()


import inptab
import minimfitab
import minimreftab
import refltab
import var_dialog
import varinpdialog
import simtab

import reader
import writer
import rebin

class TabDialog(QtGui.QDialog):
    def __init__(self, parent = None):
        QtGui.QDialog.__init__(self, parent)
        self.isoptimized = False
        self.tabWidget = QtGui.QTabWidget()
        self.inptab = inptab.Inptab()
        self.minfitab = minimfitab.Minfi()
        self.minreftab = minimreftab.Minref()
        self.refltab = refltab.Refl()
        self.vartab = varinpdialog.GuessInput()
        self.simtab = simtab.SimulationDialog()
        self.amoeba = False
        self.home = os.getenv("HOME")
        self.setMinimumSize(QtCore.QSize(320,350))
        self.connect(self.minfitab.optButton, QtCore.SIGNAL('clicked()'), self.optfi)
        self.connect(self.minfitab.plotFiButton, QtCore.SIGNAL('clicked()'), self.Plotinpfi)
        self.connect(self.minreftab.plotRButton, QtCore.SIGNAL('clicked()'), self.Plotinpen)
        self.connect(self.minreftab.optButton, QtCore.SIGNAL('clicked()'), self.optre)
        self.connect(self.minfitab.expButton, QtCore.SIGNAL('clicked()'), self.aggiornafi)
        self.connect(self.minreftab.expButton, QtCore.SIGNAL('clicked()'), self.aggiornaen)
        self.connect(self.minfitab.undoButton, QtCore.SIGNAL('clicked()'), self.undofi)
        self.connect(self.minreftab.undoButton, QtCore.SIGNAL('clicked()'), self.undoen)
        self.connect(self.inptab,QtCore.SIGNAL('dialog_mod'),self.addCombo)
        self.connect(self.inptab,QtCore.SIGNAL('dialog_del'),self.delCombo)
        self.connect(self.inptab,QtCore.SIGNAL('modify_mincombo'),self.modCombo)
        self.connect(self.minreftab.fiSelect, QtCore.SIGNAL("textChanged(QString)"), self.refltab.angle, QtCore.SLOT("setText(QString)"))
        self.connect(self.refltab.angle, QtCore.SIGNAL("textChanged(QString)"), self.minreftab.fiSelect, QtCore.SLOT("setText(QString)"))
        self.connect(self.refltab.goButton, QtCore.SIGNAL('clicked()'), self.FeffCalculations)
        self.connect(self.minfitab.saveInp, QtCore.SIGNAL('clicked()'), self.saveXMLfi)
        self.connect(self.minreftab.saveInp, QtCore.SIGNAL('clicked()'), self.saveXMLen)
        self.connect(self.simtab.plotButton, QtCore.SIGNAL('clicked()'), self.Plotsim)
        self.connect(self.simtab.saveButton, QtCore.SIGNAL('clicked()'), self.salvaSim)
        self.tabWidget.addTab(self.inptab, self.tr("Inp"))
        self.tabWidget.addTab(self.simtab, self.tr("sim"))
        self.tabWidget.addTab(self.minfitab, self.tr("Minphi"))
        self.tabWidget.addTab(self.minreftab, self.tr("Minref"))
        self.tabWidget.addTab(self.refltab, self.tr("REFL"))
        Layout = QtGui.QVBoxLayout()
        Layout.addWidget(self.tabWidget)
        self.setLayout(Layout)
        
    def aggiornafi(self):
        if self.isoptimized:
            self.vardialog = var_dialog.VarDialog()
            self.vardialog.edit.clear()
            self.vardialog.edit.append(strftime("%Y, %d/%m     %H:%M:%S"))
            self.vardialog.edit.append('Fit results for '+str(self.minfitab.fileSelect.text()))
            self.vardialog.edit.append('Method(s) used for the fit: '+str(self.inptab.optimize_combo.currentText()))
            if self.minfitab.rebinCheck.isChecked():
                self.vardialog.edit.append('Weighting of experimental data:')
                self.vardialog.edit.append('Weight of '+str(self.minfitab.eweight.text())+' given between '+str(self.minfitab.fromenergy.text())+' and '+str(self.minfitab.toenergy.text()))
            else:
                self.vardialog.edit.append('No weight specified, setting default weight to 1.0')
            self.vardialog.edit.append('')
            self.vardialog.edit.append('List of fit variables:')
            self.vardialog.edit.append('')
            for u in range(self.minfitab.table.rowCount()):
                 msg = ('%s  %s  %s ') % (str(self.minfitab.table.item(u,0).text()),str(self.minfitab.table.item(u,1).text()),str(self.minfitab.table.item(u,2).text()))
                 self.vardialog.edit.append(msg)
            self.vardialog.edit.append('')
            self.vardialog.edit.append('Output file: '+str(self.minfitab.outSelect.text()))
            self.vardialog.show()
        else:
            self.emit(QtCore.SIGNAL('add_log'), strftime('%H:%M:%S')+' - No fit performed, yet.')
        
    def aggiornaen(self):
        if self.isoptimized:
            self.vardialog = var_dialog.VarDialog()
            self.vardialog.edit.clear()
            self.vardialog.edit.append(strftime("%Y, %d/%m     %H:%M:%S"))
            self.vardialog.edit.append('Fit results for '+str(self.minreftab.fileSelect.text()))
            self.vardialog.edit.append('Method(s) used for the fit: '+str(self.inptab.optimize_combo.currentText()))
            if self.minreftab.rebinCheck.isChecked():
                self.vardialog.edit.append('Weighting of experimental data:')
                self.vardialog.edit.append('delE0 = '+str(self.minreftab.dele.text())+' eV')
                self.vardialog.edit.append('Weight of '+str(self.minreftab.eweight.text())+' given between '+str(self.minreftab.fromenergy.text())+' and '+str(self.minreftab.toenergy.text()))
            else:
                self.vardialog.edit.append('No weight specified, setting default weight to 1.0')
            self.vardialog.edit.append('')
            self.vardialog.edit.append('List of fit variables:')
            self.vardialog.edit.append('')
            for u in range(self.minreftab.table.rowCount()):
                 msg = ('%s  %s  %s ') % (str(self.minreftab.table.item(u,0).text()),str(self.minreftab.table.item(u,1).text()),str(self.minreftab.table.item(u,2).text()))
                 self.vardialog.edit.append(msg)
            self.vardialog.edit.append('')
            self.vardialog.edit.append('Output file: '+str(self.minreftab.outSelect.text()))
            self.vardialog.show()
        else:
            self.emit(QtCore.SIGNAL('add_log'), strftime('%H:%M:%S')+' - No fit performed, yet.')
        
    def FeffCalculations(self):
        self.saveXMLen('TEMP_files/feff.xml')
        self.refltab.Calculate()
        self.emit(QtCore.SIGNAL('add_log'), strftime('%H:%M:%S')+' - conversion complete')
        msg1 = strftime('%H:%M:%S')+' - %i file(s) processed' % (self.refltab.numero)
        self.emit(QtCore.SIGNAL('add_log'), msg1)
        try:
            source_1 = '%s/feff.inp' % str(self.refltab.feffEdit.text())
            dest_1 = '%s/feff.inp' % str(self.refltab.outEdit.text())
            shutil.copyfile(source_1,dest_1)
        except:
            msg = strftime('%H:%M:%S')+' - feff.inp not found in source directory! please copy the file manually! '
            self.emit(QtCore.SIGNAL('add_log'), msg)
        try:
            source_2 = '%s/files.dat' % str(self.refltab.feffEdit.text())
            dest_2 = '%s/files.dat' % str(self.refltab.outEdit.text())
            shutil.copyfile(source_2,dest_2)
        except:
            msg = strftime('%H:%M:%S')+' - files.dat not found in source directory! please copy the file manually! '
            self.emit(QtCore.SIGNAL('add_log'), msg)
        try:
            source_3 = '%s/path00.dat' % str(self.refltab.feffEdit.text())
            dest_3 = '%s/path00.dat' % str(self.refltab.outEdit.text())
            shutil.copyfile(source_3,dest_3)
        except:
            msg = strftime('%H:%M:%S')+' - path00.dat not found in source directory! please copy the file manually! '
            self.emit(QtCore.SIGNAL('add_log'), msg)
        
    def selectSave(self):
        checkcheckstatefi = False
        checkcheckstateen = False
        if not str(self.inptab.inp_n_edit.text()) == 'TEMP_files/NEW.xml' or str(self.inptab.inp_n_edit.text()) == 'TEMP_files/opt.xml':
            if self.minfitab.rebinCheck.isChecked():
                self.minfitab.rebinCheck.setChecked(False)
                checkcheckstatefi = True
            if self.minreftab.rebinCheck.isChecked():
                self.minreftab.rebinCheck.setChecked(False)
                checkcheckstateen = True
        if not str(self.inptab.inp_n_edit.text()) == '':
            if self.tabWidget.currentIndex() == 0:
                self.saveXMLinp(str(self.inptab.inp_n_edit.text()))
            elif self.tabWidget.currentIndex() == 2:
                self.saveXMLfi(str(self.inptab.inp_n_edit.text()))
            elif self.tabWidget.currentIndex() == 3:
                self.saveXMLen(str(self.inptab.inp_n_edit.text()))
            elif self.tabWidget.currentIndex() == 4:
                return
            elif self.tabWidget.currentIndex() == 1:
                return
        else:    
            if self.tabWidget.currentIndex() == 0:
                self.saveXMLinp()
            elif self.tabWidget.currentIndex() == 2:
                self.saveXMLfi()
            elif self.tabWidget.currentIndex() == 3:
                self.saveXMLen()
            elif self.tabWidget.currentIndex() == 4:
                return
            elif self.tabWidget.currentIndex() == 1:
                return
        if not str(self.inptab.inp_n_edit.text()) == 'TEMP_files/NEW.xml' or str(self.inptab.inp_n_edit.text()) == 'TEMP_files/opt.xml':
            if checkcheckstatefi:
                self.minfitab.rebinCheck.setChecked(True)
                checkcheckstatefi = False
            if checkcheckstateen:
                self.minreftab.rebinCheck.setChecked(True)
                checkcheckstateen = False
            dic_phi_out = {'WEIGHT':str(self.minfitab.rebinCheck.isChecked()),'FROM':str(self.minfitab.fromenergy.text()),'TO':str(self.minfitab.toenergy.text()),'VALUE':str(self.minfitab.eweight.text())}
            dic_en_out = {'WEIGHT':str(self.minreftab.rebinCheck.isChecked()),'FROM':str(self.minreftab.fromenergy.text()),'TO':str(self.minreftab.toenergy.text()),'VALUE':str(self.minreftab.eweight.text()),'DELE':str(self.minreftab.dele.text())}
            dic_refl_out = {'ANGLE':str(self.refltab.angle.text()),'LAYER':str(self.refltab.LayerSelect.currentText()),'ELEMENT':str(self.refltab.ElementSelect.text()),'ENERGY':str(self.refltab.E0Select.text()),'FROM_FEFF':str(self.refltab.feffEdit.text()),'TO_FEFF':str(self.refltab.outEdit.text()),'PATHS':str(self.refltab.pathsSelect.value())}
            writeit(str(self.inptab.inp_n_edit.text()), dic_phi_out,dic_en_out,dic_refl_out)
            msg = strftime('%H:%M:%S')+' - Saved '+str(self.inptab.inp_n_edit.text())
            self.emit(QtCore.SIGNAL('add_log'), msg)
            
    def saveAs(self):
        checkcheckstatefi = False
        checkcheckstateen = False
        if not str(self.inptab.inp_n_edit.text()) == 'TEMP_files/NEW.xml' or str(self.inptab.inp_n_edit.text()) == 'TEMP_files/opt.xml':
            if self.minfitab.rebinCheck.isChecked():
                self.minfitab.rebinCheck.setChecked(False)
                checkcheckstatefi = True
            if self.minreftab.rebinCheck.isChecked():
                self.minreftab.rebinCheck.setChecked(False)
                checkcheckstateen = True
        if self.tabWidget.currentIndex() == 0:
            self.saveXMLinp()
        elif self.tabWidget.currentIndex() == 2:
            self.saveXMLfi()
        elif self.tabWidget.currentIndex() == 3:
            self.saveXMLen()
        elif self.tabWidget.currentIndex() == 4:
            return
        elif self.tabWidget.currentIndex() == 1:
            return
        if not str(self.inptab.inp_n_edit.text()) == 'TEMP_files/NEW.xml' or str(self.inptab.inp_n_edit.text()) == 'TEMP_files/opt.xml':
            if checkcheckstatefi:
                self.minfitab.rebinCheck.setChecked(True)
                checkcheckstatefi = False
            if checkcheckstateen:
                self.minreftab.rebinCheck.setChecked(True)
                checkcheckstateen = False
            dic_phi_out = {'WEIGHT':str(self.minfitab.rebinCheck.isChecked()),'FROM':str(self.minfitab.fromenergy.text()),'TO':str(self.minfitab.toenergy.text()),'VALUE':str(self.minfitab.eweight.text())}
            dic_en_out = {'WEIGHT':str(self.minreftab.rebinCheck.isChecked()),'FROM':str(self.minreftab.fromenergy.text()),'TO':str(self.minreftab.toenergy.text()),'VALUE':str(self.minreftab.eweight.text()),'DELE':str(self.minreftab.dele.text())}
            dic_refl_out = {'ANGLE':str(self.refltab.angle.text()),'LAYER':str(self.refltab.LayerSelect.currentText()),'ELEMENT':str(self.refltab.ElementSelect.text()),'ENERGY':str(self.refltab.E0Select.text()),'FROM_FEFF':str(self.refltab.feffEdit.text()),'TO_FEFF':str(self.refltab.outEdit.text()),'PATHS':str(self.refltab.pathsSelect.value())}
            writeit(str(self.inptab.inp_n_edit.text()), dic_phi_out,dic_en_out,dic_refl_out)
            msg = strftime('%H:%M:%S')+' - Saved '+str(self.inptab.inp_n_edit.text())
            self.emit(QtCore.SIGNAL('add_log'), msg)
         
    def loadXML(self, in_file = None):
        if in_file is not None:
            fileName = in_file
        else:
            fileName = QtGui.QFileDialog.getOpenFileName(self, 'select file', self.home,  '*.xml;;All files ( *.* )')
            if not str(fileName) == '':
                self.inptab.inp_n_edit.setText(str(fileName))
            self.home = str(fileName)
            if str(fileName) == '':
                return
        rd = reader.ReadXml()
        fileName = str(fileName)
        
        ##################################
        # inizializza tutte le caselle
        self.minfitab.updateTable()
        self.minreftab.updateTable()
        self.refltab.LayerSelect.clear()
        self.inptab.layers = []
        self.inptab.selectCombo.clear()
        self.inptab.minim_list = []
        self.minfitab.mini = ['scan']
        self.minreftab.mini = ['scan']
        #########################################
        
        dic = rd.readInp(fileName)
        try:
            tf0 = rd.manageTF0(dic)
            self.inptab.inp_1_edit.setText(tf0)
        except:
            pass
        try:
            tf12 = rd.manageTF12(dic)
            self.inptab.inp_2_edit.setText(tf12)
        except:
            pass
        try:
            stack, repetitions = rd.manageSTACK(dic)
            
            for k in range(len(stack)):
                stack[k][1][0] = string.split(stack[k][1][0])
                stack[k][1][1] = string.split(stack[k][1][1])
                stack[k][1][2] = string.split(stack[k][1][2])
                stack[k][1][2][0] = '"density"'
                if len(stack[k][1][0]) > 2:
                    tp0 = [stack[k][0]]
                    tp0.append(stack[k][1][0])
                    self.inptab.minim_list.append(tp0)
                if len(stack[k][1][1]) > 2:
                    tp1 = [stack[k][0]]
                    tp1.append(stack[k][1][1])
                    self.inptab.minim_list.append(tp1)
                if len(stack[k][1][2]) > 2:
                    tp2 = [stack[k][0]]
                    tp2.append(stack[k][1][2])
                    self.inptab.minim_list.append(tp2)
                cps = ''
                for i in range(len(stack[k])-2):
                    stack[k][i+2][1] = string.split(stack[k][i+2][1])
                    if len(stack[k][i+2][1]) > 2:
                        tp3 = [stack[k][0],[stack[k][i+2][0],stack[k][i+2][1][0],stack[k][i+2][1][1],stack[k][i+2][1][2]]]
                        self.inptab.minim_list.append(tp3)
                    cps = cps+stack[k][i+2][0]+' '+stack[k][i+2][1][0]+';'
                layer = [stack[k][0],stack[k][1][0][1],stack[k][1][1][1],stack[k][1][2][1],cps]
                self.inptab.selectCombo.addItem(stack[k][0])
                self.refltab.LayerSelect.addItem(stack[k][0])

                self.inptab.repSpin.setValue(atoi(repetitions))
                self.inptab.layers.append(layer)
        except:
            pass
        try:
            scan = rd.manageSCAN(dic)
            for k in range(len(scan[1])):
                scan[1][k] = string.split(scan[1][k])
                if scan[1][k][0] == '"angle_factor"':
                    self.inptab.angle_edit.setText(scan[1][k][1])
                if scan[1][k][0] == '"norm"':
                    self.inptab.norm_edit.setText(scan[1][k][1])
                if scan[1][k][0] == '"noise"':
                    self.inptab.noise_edit.setText(scan[1][k][1])
            for k in range(len(scan[1])):
                if len(scan[1][k]) > 2:
                    tp = ['scan']
                    tp.append(scan[1][k])
                    self.inptab.minim_list.append(tp)
                if scan[1][k][0] == '"wavelenghts_col"':
                    if int_control(scan[1][k][1]) == 1:
                        self.minfitab.energySelect.setText(str(12398.52/string.atof(scan[1][k][1])))
                        minim_flag = 'minfi'
                    elif int_control(scan[1][k][1]) == 0:
                        self.minreftab.ESelect.setValue(-atoi(scan[1][k][1]))
                        minim_flag = 'minref'
                if scan[1][k][0] == '"angles_col"':
                    if int_control(scan[1][k][1]) == 1:
                        self.minreftab.fiSelect.setText(str(scan[1][k][1]))
                        minim_flag = 'minref'
                    elif int_control(scan[1][k][1]) == 0:
                        self.minfitab.fiSelect.setValue(string.atoi(scan[1][k][1]))
                        minim_flag = 'minfi'
                if minim_flag == 'minfi':
                    self.minfitab.fileSelect.setText(scan[0])
                    if scan[1][k][0] == '"refle_col"':
                        self.minfitab.RSelect.setValue(string.atoi(scan[1][k][1]))
                elif minim_flag == 'minref':
                    self.minreftab.fileSelect.setText(scan[0])
                    if scan[1][k][0] == '"refle_col"':
                        self.minreftab.RSelect.setValue(string.atoi(scan[1][k][1]))
                        
        except:
            pass
                    
        for h in range(len(self.inptab.layers)):
            self.minfitab.mini.append(self.inptab.layers[h][0])
            self.minreftab.mini.append(self.inptab.layers[h][0])
        try:
        
            #                 first check if one of the fit parameters is "angleshift". in that case convert to the current angle unity
            for z in range(len(self.inptab.minim_list)):
                if len(self.inptab.minim_list[z])>1:
                    if self.inptab.minim_list[z][1][0] == '"angleshift"':
                        self.inptab.minim_list[z][1][1] = str(atof(self.inptab.minim_list[z][1][1])/eval(str(self.inptab.angle_edit.text())))
                        self.inptab.minim_list[z][1][2] = str(atof(self.inptab.minim_list[z][1][2])/eval(str(self.inptab.angle_edit.text())))
                        self.inptab.minim_list[z][1][3] = str(atof(self.inptab.minim_list[z][1][3])/eval(str(self.inptab.angle_edit.text())))
                            
                    
            if minim_flag == 'minfi':
                for a in range(len(self.inptab.minim_list)):
                    item0 = self.inptab.minim_list[a]
                    if len(item0)>1:
                        self.minfitab.table.insertRow(self.minfitab.table.rowCount())
                        item_1 = QtGui.QTableWidgetItem(str(item0[0]))
                        item_2 = QtGui.QTableWidgetItem(str(item0[1][0]))
                        item_3 = QtGui.QTableWidgetItem(str(item0[1][1]))
                        item_4 = QtGui.QTableWidgetItem(str(item0[1][2]))
                        item_5 = QtGui.QTableWidgetItem(str(item0[1][3]))
                        self.minfitab.table.setItem(self.minfitab.table.rowCount()-1,0,item_1)
                        self.minfitab.table.setItem(self.minfitab.table.rowCount()-1,1,item_2)
                        self.minfitab.table.setItem(self.minfitab.table.rowCount()-1,2,item_3)
                        self.minfitab.table.setItem(self.minfitab.table.rowCount()-1,3,item_4)
                        self.minfitab.table.setItem(self.minfitab.table.rowCount()-1,4,item_5)
                
                        
                        
            if minim_flag == 'minref':
                for a in range(len(self.inptab.minim_list)):
                    item0 = self.inptab.minim_list[a]
                    if len(item0)>1:
                        self.minreftab.table.insertRow(self.minreftab.table.rowCount())
                        item_1 = QtGui.QTableWidgetItem(str(item0[0]))
                        item_2 = QtGui.QTableWidgetItem(str(item0[1][0]))
                        item_3 = QtGui.QTableWidgetItem(str(item0[1][1]))
                        item_4 = QtGui.QTableWidgetItem(str(item0[1][2]))
                        item_5 = QtGui.QTableWidgetItem(str(item0[1][3]))
                        self.minreftab.table.setItem(self.minreftab.table.rowCount()-1,0,item_1)
                        self.minreftab.table.setItem(self.minreftab.table.rowCount()-1,1,item_2)
                        self.minreftab.table.setItem(self.minreftab.table.rowCount()-1,2,item_3)
                        self.minreftab.table.setItem(self.minreftab.table.rowCount()-1,3,item_4)
                        self.minreftab.table.setItem(self.minreftab.table.rowCount()-1,4,item_5)

        except:
            pass
        
        try:
            out_file = rd.manageCpW(dic)
            if minim_flag == 'minfi':
                self.minfitab.outSelect.setText(out_file)
            elif minim_flag == 'minref':
                self.minreftab.outSelect.setText(out_file)
        except:
            pass
            
        try:
            min_file = rd.manageMIN(dic)
            self.inptab.temp_edit.setText(str(min_file[0]))
            for j in range(len(min_file)):
                min_file[j] = string.split(min_file[j])
                if min_file[j][0] == '"max_refusedcount"':
                    self.inptab.maxref_edit.setText(str(min_file[j][1]))
                elif min_file[j][0] == '"max_isthesame"':
                    self.inptab.isthesame_edit.setText(str(min_file[j][1]))
                elif min_file[j][0] == '"maxiters"':
                    self.inptab.iter_edit.setText(str(min_file[j][1]))
            self.amoeba = True
        except:
            pass
        
        if rd.manageGEFIT(dic) == 1 and not self.amoeba:
            a = self.inptab.optimize_combo.findText('Leastsq')
            self.inptab.optimize_combo.setCurrentIndex(a)
        elif rd.manageGEFIT(dic) == 0:
            a = self.inptab.optimize_combo.findText('Amoeba')
            self.inptab.optimize_combo.setCurrentIndex(a)
        elif rd.manageGEFIT(dic) == 1 and self.amoeba:
            a = self.inptab.optimize_combo.findText('Both')
            self.inptab.optimize_combo.setCurrentIndex(a)
        if not fileName == 'TEMP_files/NEW.xml': 
            if not fileName == 'TEMP_files/opt.xml':
                try:
                    in_dic_phi, in_dic_en, in_dic_refl = readit(fileName)
                    if in_dic_phi['WEIGHT'] == 'True':
                        self.minfitab.rebinCheck.setChecked(True)
                    elif in_dic_phi['WEIGHT'] == 'False':
                        self.minfitab.rebinCheck.setChecked(False)
                    self.minfitab.fromenergy.setText(in_dic_phi['FROM'])
                    self.minfitab.toenergy.setText(in_dic_phi['TO'])
                    self.minfitab.eweight.setText(in_dic_phi['VALUE'])
                    if in_dic_en['WEIGHT'] == 'True':
                        self.minreftab.rebinCheck.setChecked(True)
                    elif in_dic_en['WEIGHT'] == 'False':
                        self.minreftab.rebinCheck.setChecked(False)
                    self.minreftab.fromenergy.setText(in_dic_en['FROM'])
                    self.minreftab.toenergy.setText(in_dic_en['TO'])
                    self.minreftab.eweight.setText(in_dic_en['VALUE'])
                    self.minreftab.dele.setText(in_dic_en['DELE'])
                    try:
                        a = self.refltab.LayerSelect.findText(in_dic_refl['LAYER'])
                        self.refltab.LayerSelect.setCurrentIndex(a)
                    except:
                        pass
                    self.refltab.ElementSelect.setText(in_dic_refl['ELEMENT'])
                    self.refltab.E0Select.setText(in_dic_refl['ENERGY'])
                    self.refltab.feffEdit.setText(in_dic_refl['FROM_FEFF'])
                    self.refltab.outEdit.setText(in_dic_refl['TO_FEFF'])
                    self.refltab.angle.setText(in_dic_refl['ANGLE'])
                    self.refltab.pathsSelect.setValue(atoi(in_dic_refl['PATHS']))
                        
                except:
                    dic_phi_out = {'WEIGHT':str(self.minfitab.rebinCheck.isChecked()),'FROM':str(self.minfitab.fromenergy.text()),'TO':str(self.minfitab.toenergy.text()),'VALUE':str(self.minfitab.eweight.text())}
                    dic_en_out = {'WEIGHT':str(self.minreftab.rebinCheck.isChecked()),'FROM':str(self.minreftab.fromenergy.text()),'TO':str(self.minreftab.toenergy.text()),'VALUE':str(self.minreftab.eweight.text()),'DELE':str(self.minreftab.dele.text())}
                    dic_refl_out = {'ANGLE':str(self.refltab.angle.text()),'LAYER':str(self.refltab.LayerSelect.currentText()),'ELEMENT':str(self.refltab.ElementSelect.text()),'ENERGY':str(self.refltab.E0Select.text()),'FROM_FEFF':str(self.refltab.feffEdit.text()),'TO_FEFF':str(self.refltab.outEdit.text()),'PATHS':str(self.refltab.pathsSelect.value())}
                    writeit(str(self.inptab.inp_n_edit.text()), dic_phi_out,dic_en_out,dic_refl_out)
                    msg = strftime('%H:%M:%S')+' - File '+fileName+'.sav not found or corrupted. Creating a default one.'
                    self.emit(QtCore.SIGNAL('add_log'), msg)
                msg = strftime('%H:%M:%S')+' - Loaded '+fileName
                self.emit(QtCore.SIGNAL('add_log'), msg)            
                
                
    def saveXMLfi(self, in_file = None):
        if in_file is not None:
            fileName = in_file
        else:
            fileName = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  '*.xml;;All files ( *.* )')
            self.home = str(fileName)
            if not str(fileName) == '':
                self.inptab.inp_n_edit.setText(fileName)
            if fileName == '':
                return
        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        
        sub_stack = []
        out_stack = []
        for i in range(len(self.inptab.layers)):
            try:
                del thick, rough, dens
            except:
                pass
            if self.inptab.layers[i][0] == 'sub':
                tp_layer = [self.inptab.layers[i][0]]
                tp_comp = string.split(self.inptab.layers[i][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                for r in range(self.minfitab.table.rowCount()):
                    if self.inptab.layers[i][0] == str( self.minfitab.table.item(r,0).text()):
                        if str( self.minfitab.table.item(r,1).text()) == '"thickness"':
                            thick = str(self.minfitab.table.item(r,1).text())+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                        if str( self.minfitab.table.item(r,1).text()) == '"roughness"':
                            rough = str(self.minfitab.table.item(r,1).text())+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                        if str( self.minfitab.table.item(r,1).text()) == '"density"':
                            dens = 'density'+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                    for k in range(len(tp_comp)):
                        if self.minfitab.table.item(r,1).text() == tp_comp[k][0] and self.inptab.layers[i][0] == str( self.minfitab.table.item(r,0).text()):
                            value = str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                            tp_comp[k][1] = value
                            
                              
                try:
                    print thick
                except:
                    thick = '"thickness" '+str(self.inptab.layers[i][1])
                try:
                    print rough
                except:
                    rough = '"roughness" '+str(self.inptab.layers[i][2])
                try:
                    print dens
                except:
                    dens = 'density '+str(self.inptab.layers[i][3])
                    
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])
                sub_stack.append(tp_layer)
                wt.createSTACK(sub_stack, "1")
        if len(self.inptab.layers) > 1:
            for i in range(len(self.inptab.layers)-1):
                try:
                    del thick, rough
                except:
                    pass
                try:
                    del dens
                except:
                    pass
                tp_layer = [self.inptab.layers[i+1][0]]
                tp_comp = string.split(self.inptab.layers[i+1][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                for r in range(self.minfitab.table.rowCount()):
                    if self.inptab.layers[i+1][0] == str( self.minfitab.table.item(r,0).text()):
                        if str( self.minfitab.table.item(r,1).text()) == '"thickness"':
                            thick = str(self.minfitab.table.item(r,1).text())+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                        if str( self.minfitab.table.item(r,1).text()) == '"roughness"':
                            rough = str(self.minfitab.table.item(r,1).text())+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                        if str( self.minfitab.table.item(r,1).text()) == '"density"':
                            dens = 'density'+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                    for k in range(len(tp_comp)):
                        if self.minfitab.table.item(r,1).text() == tp_comp[k][0] and self.inptab.layers[i+1][0] == str( self.minfitab.table.item(r,0).text()):
                            value = str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                            tp_comp[k][1] = value
                
                
                try:
                    print thick
                except:
                    thick = '"thickness" '+str(self.inptab.layers[i+1][1])
                try:
                    print rough
                except:
                    rough = '"roughness" '+str(self.inptab.layers[i+1][2])
                try:
                    print dens
                except:
                    dens = 'density '+str(self.inptab.layers[i+1][3])
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])        
                out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)

    #def test(self):
        out_scan = [str(self.minfitab.fileSelect.text())]
        out_fnodes = []
        for r in range(self.minfitab.table.rowCount()):
            if str( self.minfitab.table.item(r,0).text()) == 'scan':
                data = str(self.minfitab.table.item(r,1).text())+' '+str(self.minfitab.table.item(r,2).text())+' '+str(self.minfitab.table.item(r,3).text())+' '+str(self.minfitab.table.item(r,4).text())
                out_fnodes.append(data)    
        # elimino gli elementi vuoti
        if self.minfitab.rebinCheck.isChecked():
            out_scan = ['TEMP_files/rebinned']
        # elimino gli elementi vuoti
            rb = rebin.Rebinner()
            rb.doall(str(self.minfitab.fileSelect.text()),'TEMP_files/rebinned',self.minfitab.fiSelect.value(),self.minfitab.RSelect.value(),str(self.minfitab.fromenergy.text()),str(self.minfitab.toenergy.text()),atof(str(self.minfitab.eweight.text())),0.0)
            scan_wavelenght = '"wavelenghts_col" '+str(12398.52/atof(self.minfitab.energySelect.text()))
            scan_acolon = '"angles_col" 1'
            scan_recol = '"refle_col" 2'
            scan_wecol ='"weight_col" 3'
        else:
            out_scan = [str(self.minfitab.fileSelect.text())]
            scan_wavelenght = '"wavelenghts_col" '+str(12398.52/atof(self.minfitab.energySelect.text()))
            scan_acolon = '"angles_col" '+str(self.minfitab.fiSelect.value())
            scan_recol = '"refle_col" '+str(self.minfitab.RSelect.value())
            scan_wecol ='"weight_col" 1.0'
        scan_fnodes = [scan_wavelenght,scan_acolon,scan_recol,scan_wecol]
        a_flag = False
        nm_flag = False
        ns_flag = False
        for u in range(len(out_fnodes)):
            if not out_fnodes[u] == '   ':
                scan_fnodes.append(out_fnodes[u])
        # aggiungo le altre tag per lo scan
        for v in range(len(scan_fnodes)) :
            temp_fnodes = string.split(scan_fnodes[v])
            if temp_fnodes[0] == '"angleshift"':
                temp_fnodes[1] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[1]))
                temp_fnodes[2] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[2]))
                temp_fnodes[3] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[3]))
                reconstruct = temp_fnodes[0]+' '+temp_fnodes[1]+' '+temp_fnodes[2]+' '+temp_fnodes[3]
                scan_fnodes[v] = reconstruct
            if temp_fnodes[0] == '"angle_factor"':
                a_flag = True
            if temp_fnodes[0] == '"norm"':
                nm_flag = True
            if temp_fnodes[0] == '"noise"':
                ns_flag = True
        if not a_flag:
            data = '"angle_factor" '+str(self.inptab.angle_edit.text())
            scan_fnodes.append(data)
        if not nm_flag:
            data = '"norm" '+str(self.inptab.norm_edit.text())
            scan_fnodes.append(data)
        if not ns_flag:
            data = '"noise" '+str(self.inptab.noise_edit.text())
            scan_fnodes.append(data)
        
        out_scan.append(scan_fnodes)
        wt.createSCAN(out_scan)
        wt.createFIT()
        if str(self.inptab.optimize_combo.currentText()) == 'Amoeba':
            out_maxref = '"max_refusedcount" '+str(self.inptab.maxref_edit.text())
            out_isthesame = '"max_isthesame" '+str(self.inptab.isthesame_edit.text())
            out_maxiters = '"maxiters" '+str(self.inptab.iter_edit.text())
            out_min = [str(self.inptab.temp_edit.text()), out_maxref, out_isthesame, out_maxiters]
            wt.createMIN(out_min)
        elif str(self.inptab.optimize_combo.currentText()) == 'Leastsq':
            wt.createGEFIT()
        elif str(self.inptab.optimize_combo.currentText()) == 'Both':
            out_maxref = '"max_refusedcount" '+str(self.inptab.maxref_edit.text())
            out_isthesame = '"max_isthesame" '+str(self.inptab.isthesame_edit.text())
            out_maxiters = '"maxiters" '+str(self.inptab.iter_edit.text())
            out_min = [str(self.inptab.temp_edit.text()), out_maxref, out_isthesame, out_maxiters]
            wt.createMIN(out_min)
            wt.createGEFIT()
        wt.createCpW(str(self.minfitab.outSelect.text()))
        wt.writeOutput(str(fileName))
        
                
    def saveXMLen(self, in_file = None):
        if in_file is not None:
            fileName = in_file
        else:
            fileName = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  '*.xml;;All files ( *.* )')
            self.home = str(fileName)
            if not str(fileName) == '':
                self.inptab.inp_n_edit.setText(fileName)
            if fileName == '':
                return

        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        
        sub_stack = []
        out_stack = []
        for i in range(len(self.inptab.layers)):
            try:
                del thick, rough, dens
            except:
                pass
            if self.inptab.layers[i][0] == 'sub':
                tp_layer = [self.inptab.layers[i][0]]
                tp_comp = string.split(self.inptab.layers[i][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                for r in range(self.minreftab.table.rowCount()):
                    if self.inptab.layers[i][0] == str( self.minreftab.table.item(r,0).text()):
                        if str( self.minreftab.table.item(r,1).text()) == '"thickness"':
                            thick = str(self.minreftab.table.item(r,1).text())+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                        if str( self.minreftab.table.item(r,1).text()) == '"roughness"':
                            rough = str(self.minreftab.table.item(r,1).text())+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                        if str( self.minreftab.table.item(r,1).text()) == '"density"':
                            dens = 'density'+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                    for k in range(len(tp_comp)):
                        if self.minreftab.table.item(r,1).text() == tp_comp[k][0] and self.inptab.layers[i][0] == str( self.minreftab.table.item(r,0).text()):
                            value = str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                            tp_comp[k][1] = value
                            
                              
                try:
                    print thick
                except:
                    thick = '"thickness" '+str(self.inptab.layers[i][1])
                try:
                    print rough
                except:
                    rough = '"roughness" '+str(self.inptab.layers[i][2])
                try:
                    print dens
                except:
                    dens = 'density '+str(self.inptab.layers[i][3])
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])
                sub_stack.append(tp_layer)
                wt.createSTACK(sub_stack, "1")
        if len(self.inptab.layers) > 1:
            for i in range(len(self.inptab.layers)-1):
                try:
                    del thick, rough, dens
                except:
                    pass
                tp_layer = [self.inptab.layers[i+1][0]]
                tp_comp = string.split(self.inptab.layers[i+1][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                for r in range(self.minreftab.table.rowCount()):
                    if self.inptab.layers[i+1][0] == str( self.minreftab.table.item(r,0).text()):
                        if str( self.minreftab.table.item(r,1).text()) == '"thickness"':
                            thick = str(self.minreftab.table.item(r,1).text())+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                        if str( self.minreftab.table.item(r,1).text()) == '"roughness"':
                            rough = str(self.minreftab.table.item(r,1).text())+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                        if str( self.minreftab.table.item(r,1).text()) == '"density"':
                            dens = 'density'+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                    for k in range(len(tp_comp)):
                        if self.minreftab.table.item(r,1).text() == tp_comp[k][0] and self.inptab.layers[i+1][0] == str( self.minreftab.table.item(r,0).text()):
                            value = str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                            tp_comp[k][1] = value
                
                
                try:
                    print thick
                except:
                    thick = '"thickness" '+str(self.inptab.layers[i+1][1])
                try:
                    print rough
                except:
                    rough = '"roughness" '+str(self.inptab.layers[i+1][2])
                try:
                    print dens
                except:
                    dens = 'density '+str(self.inptab.layers[i+1][3])
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])        
                out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)
        
        out_scan = [str(self.minreftab.fileSelect.text())]
        out_fnodes = []
        for r in range(self.minreftab.table.rowCount()):
            if str( self.minreftab.table.item(r,0).text()) == 'scan':
                data = str(self.minreftab.table.item(r,1).text())+' '+str(self.minreftab.table.item(r,2).text())+' '+str(self.minreftab.table.item(r,3).text())+' '+str(self.minreftab.table.item(r,4).text())
                out_fnodes.append(data) 
        if self.minreftab.rebinCheck.isChecked():
            out_scan = ['TEMP_files/rebinned']
        # elimino gli elementi vuoti
            rb = rebin.Rebinner()
            rb.doall(str(self.minreftab.fileSelect.text()),'TEMP_files/rebinned',self.minreftab.ESelect.value(),self.minreftab.RSelect.value(),str(self.minreftab.fromenergy.text()),str(self.minreftab.toenergy.text()),atof(str(self.minreftab.eweight.text())),atof(str(self.minreftab.dele.text())))
            scan_wavelenght = '"wavelenghts_col" -1'
            scan_acolon = '"angles_col" '+str(self.minreftab.fiSelect.text())
            scan_recol = '"refle_col" 2'
            scan_wecol = '"weight_col" 3'
        else:
            out_scan = [str(self.minreftab.fileSelect.text())]
            scan_wavelenght = '"wavelenghts_col" '+str(-self.minreftab.ESelect.value())
            scan_acolon = '"angles_col" '+str(self.minreftab.fiSelect.text())
            scan_recol = '"refle_col" '+str(self.minreftab.RSelect.value())
            scan_wecol = '"weight_col" 1.0'
        scan_fnodes = [scan_wavelenght,scan_acolon,scan_recol,scan_wecol]
        a_flag = False
        nm_flag = False
        ns_flag = False
        for u in range(len(out_fnodes)):
            if out_fnodes[u][0] != ' ':
                scan_fnodes.append(out_fnodes[u])
        
        # aggiungo le altre tag per lo scan
        for v in range(len(scan_fnodes)) :
            temp_fnodes = string.split(scan_fnodes[v])
            if temp_fnodes[0] == '"angleshift"':
                temp_fnodes[1] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[1]))
                temp_fnodes[2] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[2]))
                temp_fnodes[3] = str(eval(str(self.inptab.angle_edit.text()))*atof(temp_fnodes[3]))
                reconstruct = temp_fnodes[0]+' '+temp_fnodes[1]+' '+temp_fnodes[2]+' '+temp_fnodes[3]
                scan_fnodes[v] = reconstruct
            if temp_fnodes[0] == '"angle_factor"':
                a_flag = True
            if temp_fnodes[0] == '"norm"':
                nm_flag = True
            if temp_fnodes[0] == '"noise"':
                ns_flag = True
        if not a_flag:
            data = '"angle_factor" '+str(self.inptab.angle_edit.text())
            scan_fnodes.append(data)
        if not nm_flag:
            data = '"norm" '+str(self.inptab.norm_edit.text())
            scan_fnodes.append(data)
        if not ns_flag:
            data = '"noise" '+str(self.inptab.noise_edit.text())
            scan_fnodes.append(data)
        out_scan.append(scan_fnodes)
        wt.createSCAN(out_scan)
        wt.createFIT()
        if str(self.inptab.optimize_combo.currentText()) == 'Amoeba':
            out_maxref = '"max_refusedcount" '+str(self.inptab.maxref_edit.text())
            out_isthesame = '"max_isthesame" '+str(self.inptab.isthesame_edit.text())
            out_maxiters = '"maxiters" '+str(self.inptab.iter_edit.text())
            out_min = [str(self.inptab.temp_edit.text()), out_maxref, out_isthesame, out_maxiters]
            wt.createMIN(out_min)
        elif str(self.inptab.optimize_combo.currentText()) == 'Leastsq':
            wt.createGEFIT()
        elif str(self.inptab.optimize_combo.currentText()) == 'Both':
            out_maxref = '"max_refusedcount" '+str(self.inptab.maxref_edit.text())
            out_isthesame = '"max_isthesame" '+str(self.inptab.isthesame_edit.text())
            out_maxiters = '"maxiters" '+str(self.inptab.iter_edit.text())
            out_min = [str(self.inptab.temp_edit.text()), out_maxref, out_isthesame, out_maxiters]
            wt.createMIN(out_min)
            wt.createGEFIT()
        wt.createCpW(str(self.minreftab.outSelect.text()))
        wt.writeOutput(str(fileName))
        
    def saveXMLinp(self, in_file = None):
        if in_file is not None:
            fileName = in_file
        else:
            fileName = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  '*.xml;;All files ( *.* )')
            self.home = str(fileName)
            if not str(fileName) == '':
                self.inptab.inp_n_edit.setText(fileName)
            if fileName == '':
                return
        
        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        sub_stack = []
        out_stack = []
        for i in range(len(self.inptab.layers)):
            if self.inptab.layers[i][0] == 'sub':
                tp_layer = [self.inptab.layers[i][0]]
                tp_comp = string.split(self.inptab.layers[i][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                thick = '"thickness" '+str(self.inptab.layers[i][1])
                rough = '"roughness" '+str(self.inptab.layers[i][2])
                dens = 'density '+str(self.inptab.layers[i][3])
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])
                sub_stack.append(tp_layer)
                wt.createSTACK(sub_stack, "1")
        if len(self.inptab.layers) > 1:
            for i in range(len(self.inptab.layers)-1):
                tp_layer = [self.inptab.layers[i+1][0]]
                tp_comp = string.split(self.inptab.layers[i+1][4],';')
                for z in range(len(tp_comp)):
                    if tp_comp[z] == '':
                        del tp_comp[z]
                    elif not tp_comp[z] == '':
                        tp_comp[z] = string.split(tp_comp[z])
                thick = '"thickness" '+str(self.inptab.layers[i+1][1])
                rough = '"roughness" '+str(self.inptab.layers[i+1][2])
                dens = 'density '+str(self.inptab.layers[i+1][3])
                data_list = [thick,rough,dens]
                tp_layer.append(data_list)
                for y in range(len(tp_comp)):
                    tp_layer.append(tp_comp[y])
                out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)
        wt.writeOutput(str(fileName))
            

    def newResfi(self, in_file = None):
        
        if in_file is not None:
            infile = in_file
        else:
            infile = str(self.inptab.inp_n_edit.text())
        try:
            del s
        except:
            pass
        s = ppmxml.get_script(infile)
        
        exec(s)
        self.emit(QtCore.SIGNAL('add_log'),strftime('%H:%M:%S')+' - Data fitted!')
        result = []
        angolo = 1/eval(str(self.inptab.angle_edit.text()))
        result.append(angolo*fit2.scanlist[0][1])
        result.append(fit2.scanlist[0][2])
        result.append(fit2.calculatedscan[0])
        result.append('fi')
        self.emit(QtCore.SIGNAL('test_func'), result)
        import sub
        reload(sub)
        subclass = sub.Sub()
        sl = string.split(open( infile,"r").read(),"\n" )
        ppmxml.variables_list.reverse()
        for var in ppmxml.variables_list:
            pos = ppmxml.variables_pos[var]
            nl = pos[0]-1
            nc = pos[1]
            sz = pos[2]
            sl[nl] = sl[nl][:nc]+str(getattr(subclass, var)) + sl[nl][nc+sz:]

        f=open('TEMP_files/NEW.xml',"w")
        for l in sl:
            f.write( l+"\n")
        f.close()
        # read variables result
        self.isoptimized = True
        temp = str(self.minfitab.fileSelect.text())
        self.loadXML('TEMP_files/NEW.xml')
        self.minfitab.fileSelect.setText(temp)

        
        
    def newResen(self, in_file = None):
        if in_file is not None:
            infile = in_file
        else:
            infile = str(self.inptab.inp_n_edit.text())
        try:
            del s
        except:
            pass
        s = ppmxml.get_script(infile)
        exec(s)
        self.emit(QtCore.SIGNAL('add_log'),strftime('%H:%M:%S')+' - Data fitted!')
        result = []
        energia = []
        for i in range(len(fit2.scanlist[0][0])):
            energia.append(12398.52/fit2.scanlist[0][0][i])
        result.append(array(energia))
        result.append(fit2.scanlist[0][2])
        result.append(fit2.calculatedscan[0])
        result.append('en')
        self.emit(QtCore.SIGNAL('test_func'), result)
                # read variables result
        import sub
        reload(sub)

        subclass = sub.Sub()
        sl = string.split(open( infile,"r").read(),"\n" )
        ppmxml.variables_list.reverse()
        for var in ppmxml.variables_list:
            pos = ppmxml.variables_pos[var]
            nl = pos[0]-1
            nc = pos[1]
            sz = pos[2]
            sl[nl] = sl[nl][:nc]+str(getattr(subclass, var)) + sl[nl][nc+sz:]

        f=open('TEMP_files/NEW.xml',"w")
        for l in sl:
            f.write( l+"\n")
        f.close()
        self.isoptimized = True
        temp = str(self.minreftab.fileSelect.text())
        self.loadXML('TEMP_files/NEW.xml')
        self.minreftab.fileSelect.setText(temp)
        
        for i in range(self.minreftab.table.rowCount()):
            if str(self.minreftab.table.item(i,1).text()) == '"angleshift"':
                newfi = str(atof(str(self.minreftab.fiSelect.text()))+atof(str(self.minreftab.table.item(i,2).text())))
                self.minreftab.fiSelect.setText(newfi)
        
    def addCombo(self, msg):
        self.minfitab.mini.append(msg)
        self.minreftab.mini.append(msg)
        self.refltab.LayerSelect.addItem(msg)
        
    def delCombo(self, msg):
        a = self.refltab.LayerSelect.findText(msg)
        for i in range(len(self.minfitab.mini)):
            if self.minfitab.mini[i] == msg:
                del self.minfitab.mini[i]
        for i in range(len(self.minreftab.mini)):
            if self.minreftab.mini[i] == msg:
                del self.minreftab.mini[i]
        self.refltab.LayerSelect.removeItem(a)
    def modCombo(self, msg):
        tp = self.minfitab.mini[msg[0]+1]
        self.minfitab.mini[msg[0]+1] = msg[1]
        self.minfitab.mini[msg[0]+1] = msg[1]
        for i in range(self.minfitab.table.rowCount()):
            if self.minfitab.table.item(i,0).text() == tp:
                item0 = QtGui.QTableWidgetItem(str(msg[1]))
                self.minfitab.table.setItem(i,0, item0)
        for i in range(self.minreftab.table.rowCount()):
            if self.minreftab.table.item(i,0).text() == tp:
                item0 = QtGui.QTableWidgetItem(str(msg[1]))
                self.minreftab.table.setItem(i,0, item0)
                
        self.refltab.LayerSelect.setItemText(msg[0], msg[1])
    def undofi(self):
        if self.isoptimized:
            temp = str(self.minfitab.fileSelect.text())
            self.loadXML('TEMP_files/opt.xml')
            self.minfitab.fileSelect.setText(temp)
        else:
            self.emit(QtCore.SIGNAL('add_log'), strftime('%H:%M:%S')+' - No fit performed, yet.')
            return
    def undoen(self):
        if self.isoptimized:
            temp = str(self.minreftab.fileSelect.text())
            self.loadXML('TEMP_files/opt.xml')
            self.minreftab.fileSelect.setText(temp)
        else:
            self.emit(QtCore.SIGNAL('add_log'), strftime('%H:%M:%S')+' - No fit performed, yet.')
            return 
    def optfi(self):
        self.saveXMLfi('TEMP_files/opt.xml')
        return self.newResfi('TEMP_files/opt.xml')
    def optre(self):
        self.saveXMLen('TEMP_files/opt.xml')
        return self.newResen('TEMP_files/opt.xml')
    
    def Plotinpen(self):
        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        out_stack = []
        for i in range(len(self.inptab.layers)):
            tp_layer = [self.inptab.layers[i][0]]
            tp_comp = string.split(self.inptab.layers[i][4],';')
            for z in range(len(tp_comp)):
                if tp_comp[z] == '':
                    del tp_comp[z]
                elif not tp_comp[z] == '':
                    tp_comp[z] = string.split(tp_comp[z])
            thick = '"thickness" '+str(self.inptab.layers[i][1])
            rough = '"roughness" '+str(self.inptab.layers[i][2])
            dens = 'density '+str(self.inptab.layers[i][3])
            data_list = [thick,rough,dens]
            tp_layer.append(data_list)
            for y in range(len(tp_comp)):
                tp_layer.append(tp_comp[y])
            out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)
        
        out_scan = [str(self.minreftab.fileSelect.text())]
        weight = '"weight_col" 1.0'
        noise = '"noise" '+str(self.inptab.noise_edit.text())
        norm = '"norm" '+str(self.inptab.norm_edit.text())
        angle = '"angle_factor" '+str(self.inptab.angle_edit.text())
        scan_wavelenght = '"wavelenghts_col" '+str(-self.minreftab.ESelect.value())
        scan_acolon = '"angles_col" '+str(self.minreftab.fiSelect.text())
        scan_recol = '"refle_col" '+str(self.minreftab.RSelect.value())
        scan_fnodes = [scan_wavelenght,scan_acolon,scan_recol,weight,angle,norm,noise]
        out_scan.append(scan_fnodes)
        wt.createSCAN(out_scan)
        wt.createFIT()
        wt.createCpW('TEMP_files/temp_out')
        wt.writeOutput('TEMP_files/plot.xml')
        s = ppmxml.get_script('TEMP_files/plot.xml')
        exec(s)
        result = []
        energia = []
        for i in range(len(fit2.scanlist[0][0])):
            energia.append(12398.52/fit2.scanlist[0][0][i])
        result.append(energia)
        energia = array(energia)
        sh_en = energia - atof(str(self.minreftab.dele.text()))
        refle = array(fit2.scanlist[0][2])
        iff.put_array('a.en',energia)
        iff.put_array('a.re',refle)
        iff.put_array('b.en',sh_en)
        iff.ifeffit('b.re = rebin(a.en,a.re,b.en)')
        rebin_ref = array(iff.get_array('b.re'))
        iff.ifeffit('erase @arrays')
        result.append(rebin_ref)
        result.append(fit2.calculatedscan[0])
        result.append('en')
        self.emit(QtCore.SIGNAL('test_func'), result)
        
    def Plotinpfi(self):
        fileName = 'TEMP_files/plot.xml'
        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        out_stack = []
        for i in range(len(self.inptab.layers)):
            tp_layer = [self.inptab.layers[i][0]]
            tp_comp = string.split(self.inptab.layers[i][4],';')
            for z in range(len(tp_comp)):
                if tp_comp[z] == '':
                    del tp_comp[z]
                elif not tp_comp[z] == '':
                    tp_comp[z] = string.split(tp_comp[z])
            thick = '"thickness" '+str(self.inptab.layers[i][1])
            rough = '"roughness" '+str(self.inptab.layers[i][2])
            dens = 'density '+str(self.inptab.layers[i][3])
            data_list = [thick,rough,dens]
            tp_layer.append(data_list)
            for y in range(len(tp_comp)):
                tp_layer.append(tp_comp[y])
            out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)
        
        out_scan = [str(self.minfitab.fileSelect.text())]
        weight = '"weight_col" 1.0'
        noise = '"noise" '+str(self.inptab.noise_edit.text())
        norm = '"norm" '+str(self.inptab.norm_edit.text())
        angle = '"angle_factor" '+str(self.inptab.angle_edit.text())
        scan_wavelenght = '"wavelenghts_col" '+str(12398.52/atof(self.minfitab.energySelect.text()))
        scan_acolon = '"angles_col" '+str(self.minfitab.fiSelect.value())
        scan_recol = '"refle_col" '+str(self.minfitab.RSelect.value())
        scan_fnodes = [scan_wavelenght,scan_acolon,scan_recol,weight,angle,norm,noise]
        out_scan.append(scan_fnodes)
        wt.createSCAN(out_scan)
        wt.createFIT()
        wt.createCpW('TEMP_files/temp_out')
        wt.writeOutput(str(fileName))
        s = ppmxml.get_script(str(fileName))
        exec(s)
        result = []
        angolo = 1/eval(str(self.inptab.angle_edit.text()))
        result.append(angolo*fit2.scanlist[0][1])
        result.append(fit2.scanlist[0][2])
        result.append(fit2.calculatedscan[0])
        result.append('fi')
        self.emit(QtCore.SIGNAL('test_func'), result)
        
    def Plotsim(self):
        wt = writer.WriteXml()
        tf0_inp = str(self.inptab.inp_1_edit.text())
        wt.createTF0(tf0_inp)
        tf12_inp = str(self.inptab.inp_2_edit.text())
        wt.createTF12(tf12_inp)
        out_stack = []
        for i in range(len(self.inptab.layers)):
            tp_layer = [self.inptab.layers[i][0]]
            tp_comp = string.split(self.inptab.layers[i][4],';')
            for z in range(len(tp_comp)):
                if tp_comp[z] == '':
                    del tp_comp[z]
                elif not tp_comp[z] == '':
                    tp_comp[z] = string.split(tp_comp[z])
            thick = '"thickness" '+str(self.inptab.layers[i][1])
            rough = '"roughness" '+str(self.inptab.layers[i][2])
            dens = 'density '+str(self.inptab.layers[i][3])
            data_list = [thick,rough,dens]
            tp_layer.append(data_list)
            for y in range(len(tp_comp)):
                tp_layer.append(tp_comp[y])
            out_stack.append(tp_layer)
        repetitions = str(self.inptab.repSpin.value())
        wt.createSTACK(out_stack, repetitions)
        
        out_scan = []
        noise = '"noise" '+str(self.inptab.noise_edit.text())
        norm = '"norm" '+str(self.inptab.norm_edit.text())
        angle = '"angle_factor" '+str(self.inptab.angle_edit.text())
        
        if str(self.simtab.scanCombo.currentText()) == 'Angle':
            step = (atof(str(self.simtab.toEdit.text()))-atof(str(self.simtab.fromEdit.text())))/atof(str(self.simtab.stepEdit.text()))
            scan_wavelenght = '"wavelenghts_col" '+str(12398.52/atof(str(self.simtab.valore.text())))
            scan_acolon = '"angles_col" ['+str(self.simtab.fromEdit.text())+','+str(self.simtab.toEdit.text())+','+str(step)+']'
        elif str(self.simtab.scanCombo.currentText()) == 'Energy (eV)':
            step = (12398.52/atof(str(self.simtab.fromEdit.text()))-12398.52/atof(str(self.simtab.toEdit.text())))/(atof(str(self.simtab.stepEdit.text())))
            scan_wavelenght = '"wavelenghts_col" ['+str(12398.52/atof(str(self.simtab.toEdit.text())))+','+str(12398.52/atof(str(self.simtab.fromEdit.text())))+','+str(step)+']'
            scan_acolon = '"angles_col" '+str(self.simtab.valore.text())
        scan_fnodes = [scan_wavelenght,scan_acolon,angle,norm,noise]
        out_scan.append(scan_fnodes)
        wt.createSCAN(out_scan)
        wt.createFIT()
        wt.createCpW('TEMP_files/sim_out')
        wt.writeOutput('TEMP_files/plot.xml')
        s = ppmxml.get_script('TEMP_files/plot.xml')
        exec(s)
        result = []
        ascissa = []
        ordinata = []
        if str(self.simtab.scanCombo.currentText()) == 'Energy (eV)':
            for i in range(len(fit2.scanlist[0][0])):
                ascissa.append(12398.52/fit2.scanlist[0][0][len(fit2.scanlist[0][0])-i-1])
                ordinata.append(fit2.calculatedscan[0][len(fit2.scanlist[0][0])-i-1])
            ascissa = array(ascissa)
            ordinata = array(ordinata)
            result.append(ascissa)
            result.append(ordinata)
        elif str(self.simtab.scanCombo.currentText()) == 'Angle':
            angolo = 1/eval(str(self.inptab.angle_edit.text()))
            result.append(angolo*fit2.scanlist[0][1])
            result.append(fit2.calculatedscan[0])
        if str(self.simtab.scanCombo.currentText()) == 'Energy (eV)':
            result.append('en')
        elif str(self.simtab.scanCombo.currentText()) == 'Angle':
            result.append('fi')
        self.emit(QtCore.SIGNAL('sim_func'), result)
    def salvaSim(self):
        out = QtGui.QFileDialog.getSaveFileName(self,'select file', self.home,  'Ascii files ( *.txt *.dat ) ;;All files ( *.* )')
        if len(out) == 0:
            return
        out = str(out)
        sim_file = loadtxt('TEMP_files/sim_out1',unpack=True)
        if str(self.simtab.scanCombo.currentText()) == 'Energy (eV)':
            ascissa = []
            ordinata = []
            for i in range(len(sim_file[0])):
                ascissa.append(12398.52/sim_file[1][len(sim_file[0])-i-1])
                ordinata.append(sim_file[0][len(sim_file[0])-i-1])
            ascissa = array(ascissa)
            ordinata = array(ordinata)
            savetxt(out, transpose((ascissa,ordinata)),fmt='%1.8e')
        elif str(self.simtab.scanCombo.currentText()) == 'Angle':
            angolo = 1/eval(str(self.inptab.angle_edit.text()))
            ascissa = angolo*sim_file[2]
            ordinata = sim_file[0]
            savetxt(out, transpose((ascissa,ordinata)),fmt='%1.8e')
            
def int_control(inp):
    if string.find(inp, '.') > 0:
        out = 1
    else:
        out = 0
    return out

def readit(inp_file):

    file = open(inp_file+'.sav','r')
    lines = string.split(file.read(), '\n')
    file.close()
    if lines[0] == 'MINPHI':
        minphi_0 = lines[1:5]
    if lines[5] == 'MINREF':
        minref_0 = lines[6:11]
    if lines[11] == 'REFL':
        refl_0 = lines[12:19]
        
    minphi = {}
    minref = {}
    refl = {}

    for line in minphi_0:
        try:
            minphi[string.split(line)[0]] = string.split(line)[1]
        except:
            minphi[string.split(line)[0]] = ' '
    for line in minref_0:
        try:
            minref[string.split(line)[0]] = string.split(line)[1]
        except:
            minref[string.split(line)[0]] = ' '
    for line in refl_0:
        try:
            refl[string.split(line)[0]] = string.split(line)[1]
        except:
            refl[string.split(line)[0]] = ' '
    return minphi,minref,refl


def writeit(out_file, phi,en,refl):
    file = open(out_file+'.sav', 'w')
    file.write('MINPHI\n')
    for chiave in phi.keys():
        file.write(chiave+' '+phi[chiave]+'\n')
    file.write('MINREF\n')
    for chiave in en.keys():
        file.write(chiave+' '+en[chiave]+'\n')
    file.write('REFL\n')
    for chiave in refl.keys():
        file.write(chiave+' '+refl[chiave]+'\n')
    file.close()       


if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = TabDialog()
    qb.show()
    qb.loadXML('7nio_fi.xml')
    qb.saveXMLfi('ciao.xml')
    sys.exit(app.exec_())
