#from xml.dom.minidom import *
import xml.dom.minidom as md
from string import *
import cStringIO

# only for testing purpose
import reader

inp_file = 'test.xml'
out_file = 'out_test.xml'


# to replace &quot; with " when writing back to xml
def wd(writer, data):
    data = data.replace("&", "&amp;").replace("<", "&lt;")
    writer.write(data)

md._write_data = wd


class WriteXml:

    def __init__(self, parent = None):
        self.doc = md.Document()
        self.sys_node = self.doc.createElement('system')
        self.doc.appendChild(self.sys_node)

    def createTF0(self, inp):
        tf0 = self.doc.createElement('tf0')
        s_node = self.doc.createElement('s')
        text = self.doc.createTextNode(inp)
        s_node.appendChild(text)
        tf0.appendChild(s_node)
        self.sys_node.appendChild(tf0)

    def createTF12(self, inp):
        tf12 = self.doc.createElement('tf12')
        s_node = self.doc.createElement('s')
        text = self.doc.createTextNode(inp)
        s_node.appendChild(text)
        tf12.appendChild(s_node)
        self.sys_node.appendChild(tf12)

    def createIFT(self, inp):
        for i in range(len(inp)):
            ift = self.doc.createElement('ift')
            text = self.doc.createTextNode(inp[i][0])
            ift.appendChild(text)
            s_node =  self.doc.createElement('s')
            s_text = self.doc.createTextNode(inp[i][1])
            s_node.appendChild(s_text)
            f_node = self.doc.createElement('f')
            f_text = self.doc.createTextNode(inp[i][2])
            f_node.appendChild(f_text)
            ift.appendChild(s_node)
            ift.appendChild(f_node)
            self.sys_node.appendChild(ift)

    def createBFF(self, inp):
        for i in range(len(inp)):
            bff = self.doc.createElement('bff')
            text = self.doc.createTextNode(inp[i][0])
            bff.appendChild(text)
            s_node =  self.doc.createElement('s')
            s_text = self.doc.createTextNode(inp[i][1])
            s_node.appendChild(s_text)
            bff.appendChild(s_node)
            for k in range(len(inp[i])-2):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[i][k+2])
                f_node.appendChild(f_text)
                bff.appendChild(f_node)
            self.sys_node.appendChild(bff)

    def createBSUM(self, inp):
        for i in range(len(inp)):
            bsum = self.doc.createElement('bsum')
            text = self.doc.createTextNode(inp[i][0])
            bsum.appendChild(text)
            for k in range(len(inp[i])-1):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[i][k+1])
                f_node.appendChild(f_text)
                bsum.appendChild(f_node)
            self.sys_node.appendChild(bsum)

    def createKK(self, inp):
                #print inp[0]
        for i in range(len(inp)):
            KK = self.doc.createElement('KK')
            text = self.doc.createTextNode(inp[i][0])
            KK.appendChild(text)
            bjoin = self.doc.createElement('bjoin')
            bjoin.setAttribute('key','filename_or_betaObject')
            for k in range(len(inp[i][1])):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[i][1][k])
                f_node.appendChild(f_text)
                bjoin.appendChild(f_node)
            KK.appendChild(bjoin)
            for m in range(len(inp[i])-2):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[i][m+2])
                f_node.appendChild(f_text)
                KK.appendChild(f_node)
        self.sys_node.appendChild(KK)
        
    def createSTACK(self, inp, rep):
        STACK = self.doc.createElement('stack')
        if atoi(rep) > 1:
            STACK.setAttribute('repetitions', rep)
        for i in range(len(inp)):
            layer = self.doc.createElement('layer')
            layer_text = self.doc.createTextNode(inp[i][0])
            layer.appendChild(layer_text)
            t_node = self.doc.createElement('f')
            t_text = self.doc.createTextNode(inp[i][1][0])
            t_node.appendChild(t_text)
            r_node = self.doc.createElement('f')
            r_text = self.doc.createTextNode(inp[i][1][1])
            r_node.appendChild(r_text)
            layer.appendChild(t_node)
            layer.appendChild(r_node)
            if not inp[i][2] == 'iff':
                densita = self.doc.createElement('f')
                densita_text = self.doc.createTextNode(str(inp[i][0])+'_'+str(inp[i][1][2]))
                densita.appendChild(densita_text)
                self.sys_node.appendChild(densita)
                ift = self.doc.createElement('ift')
                ift.setAttribute('key','material')
                for k in range(len(inp[i])-2):
                    variab = self.doc.createElement('f')
                    variab_text = self.doc.createTextNode(str(inp[i][0])+'_'+str(inp[i][k+2][0])+' '+str(inp[i][k+2][1]))
                    variab.appendChild(variab_text)
                    self.sys_node.appendChild(variab)
                    dep_veriab = self.doc.createElement('dv')
                    dep_veriab_text = self.doc.createTextNode(str(inp[i][0])+'_'+str(inp[i][k+2][0])+'_density')
                    dep_veriab.appendChild(dep_veriab_text)
                    dep_v2 = self.doc.createElement('s')
                    dep_v2_text = self.doc.createTextNode('par('+str(inp[i][0])+'_density'+')*par('+str(inp[i][0])+'_'+str(inp[i][k+2][0])+')')
                    dep_v2.appendChild(dep_v2_text)
                    dep_veriab.appendChild(dep_v2)
                    self.sys_node.appendChild(dep_veriab)
                    s_node = self.doc.createElement('s')
                    s_text = self.doc.createTextNode(inp[i][k+2][0])
                    s_node.appendChild(s_text)
                    ift.appendChild(s_node)
                    f_node = self.doc.createElement('f')
                    f_text = self.doc.createTextNode(str(inp[i][0])+'_'+str(inp[i][k+2][0])+'_density')
                    f_node.appendChild(f_text)
                    ift.appendChild(f_node)
                layer.appendChild(ift)
            else:
                iff = self.doc.createElement('iff')
                iff.setAttribute('key','material')
                s_node = self.doc.createElement('s')
                s_text = self.doc.createTextNode(inp[i][3])
                s_node.appendChild(s_text)
                iff.appendChild(s_node)
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode('1.0')
                f_node.appendChild(f_text)
                iff.appendChild(f_node)
                layer.appendChild(iff)
            STACK.appendChild(layer)
                
        self.sys_node.appendChild(STACK)
        
    def createSCAN(self, inp):
        slist_node = self.doc.createElement('scanlist')
        scan_node = self.doc.createElement('scan')
        if len(inp) == 2 :
            s_node = self.doc.createElement('s')
            s_node.setAttribute('key','filename')
            s_text = self.doc.createTextNode(inp[0])
            s_node.appendChild(s_text)
            scan_node.appendChild(s_node)
            for i in range(len(inp[1])):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[1][i])
                f_node.appendChild(f_text)
                scan_node.appendChild(f_node)
        else:
           for i in range(len(inp[0])):
                f_node = self.doc.createElement('f')
                f_text = self.doc.createTextNode(inp[0][i])
                f_node.appendChild(f_text)
                scan_node.appendChild(f_node) 
        slist_node.appendChild(scan_node)
        self.sys_node.appendChild(slist_node)
        
    def createFIT(self):
        fit_node = self.doc.createElement('fit')
        fit_text = self.doc.createTextNode('fit2')
        fit_node.appendChild(fit_text)
        f_node = self.doc.createElement('f')
        f_text = self.doc.createTextNode('"width" 0')
        f_node.appendChild(f_text)
        fit_node.appendChild(f_node)
        self.sys_node.appendChild(fit_node)
        
        
    def createCpW(self, inp):
        cpw_node = self.doc.createElement('comparison_write')
        f_node = self.doc.createElement('f')
        f_text = self.doc.createTextNode('fit2')
        f_node.appendChild(f_text)
        s_node = self.doc.createElement('s')
        s_text = self.doc.createTextNode(str(inp))
        s_node.appendChild(s_text)
        cpw_node.appendChild(f_node)
        cpw_node.appendChild(s_node)
        self.sys_node.appendChild(cpw_node)
        
    def createMIN(self, inp):
        min_node = self.doc.createElement('Minimise')
        f1_node = self.doc.createElement('f')
        f1_text = self.doc.createTextNode('"fit" fit2')
        f1_node.appendChild(f1_text)
        min_node.appendChild(f1_node)
        s_node = self.doc.createElement('s')
        s_node.setAttribute('key','temperature')
        s_text = self.doc.createTextNode(inp[0])
        s_node.appendChild(s_text)
        min_node.appendChild(s_node)
        f2_node = self.doc.createElement('f')
        f2_text = self.doc.createTextNode(inp[1])
        f2_node.appendChild(f2_text)
        min_node.appendChild(f2_node)
        f3_node = self.doc.createElement('f')
        f3_text = self.doc.createTextNode(inp[2])
        f3_node.appendChild(f3_text)
        min_node.appendChild(f3_node)
        f4_node = self.doc.createElement('f')
        f4_text = self.doc.createTextNode(inp[3])
        f4_node.appendChild(f4_text)
        min_node.appendChild(f4_node)
        self.sys_node.appendChild(min_node)
        
    def createGEFIT(self):
        min_node = self.doc.createElement('MinimiseGeFit')   
        f1_node = self.doc.createElement('f')
        f1_text = self.doc.createTextNode('"fit" fit2')
        f1_node.appendChild(f1_text)
        min_node.appendChild(f1_node)
        self.sys_node.appendChild(min_node)                   


    def writeOutput(self, out):
        file = open(out, 'w')
        #file.writelines(self.doc.toprettyxml())
        s = cStringIO.StringIO()
        self.doc.writexml(s)
        file.writelines(s.getvalue())
        file.close()
        #print s.getvalue()

if __name__ == '__main__':
    rd = reader.ReadXml()
    dic = rd.readInp(inp_file)
    tf0_inp = rd.manageTF0(dic)
    tf12_inp = rd.manageTF12(dic)
    #ift_inp = rd.manageIFT(dic)
    #bff_inp = rd.manageBFF(dic)
    #bsum_inp = rd.manageBSUM(dic)
    #KK_inp = rd.manageKK(dic)
    stack_inp, repe = rd.manageSTACK(dic)
    scan_inp = rd.manageSCAN(dic)
    Cpw_inp = rd.manageCpW(dic)
    

    wt = WriteXml()
    wt.createTF0(tf0_inp)
    wt.createTF12(tf12_inp)
    #wt.createIFT(ift_inp)
    #wt.createBFF(bff_inp)
    #wt.createBSUM(bsum_inp)
    #wt.createKK(KK_inp)
    wt.createSTACK(stack_inp, repe)
    wt.createSCAN(scan_inp)
    wt.createFIT()
    wt.createCpW(Cpw_inp)
    wt.writeOutput(out_file)

